//#################################################################
//fontsoft.c
//
//Text mit Software Font schreiben
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 26.02.2006
// Compiler: MCC18 V2.3
//#################################################################
#include <p18cxxx.h>
#include "ks108.h"

unsigned char fontwidth,fontheight;   //Breite,Hhe in Pixeln
unsigned char font;

//Irgendwie klappte es mit den Arrays und Pointern nicht wie bei AVR-GCC
//Deshalb etwas umstndlicher mit vielen if() Abfragen
//und der korrekten Angabe der Array Gren.

extern const rom unsigned char f8x8a[256][8];

//########################################################################
void SetFont(unsigned char num)
//########################################################################
{
 switch(num)
  {
   case 1: fontwidth=8; fontheight=8; font=1; break; //f8x8a
   default: fontwidth=0; fontheight=0; font=0; break;
  }
}

//########################################################################
//Schreibt ein einzelnes Zeichen an Position x,y
void LCDSoftChar(unsigned char ch, unsigned char xpos, unsigned char ypos)
//########################################################################
{
unsigned char by,i;
rom unsigned char *ptr;

 if(font==0) return;

 SetPosition(xpos,ypos);
 for(i=0; i<fontwidth; i++) //ber die Breite des Zeichens
  {
     if(font==1) ptr=&f8x8a[ch][i];

     by=*ptr; //Ein Byte des Zeichens holen
     WriteDisplay(by);       //8 Pixel schreiben

  }//for i
}

//########################################################################
//Schreibt einen Text an Position x,y
//Mit automatischem Zeilenvorschub falls der Text zu lang war.
//Noch keine Steuerzeichen wie TAB,CR,LF integriert
void LCDSoftText(const rom char *__putstr, unsigned char xpos, unsigned char ypos)
//########################################################################
{
 char __ps;
 unsigned char xp,yp;

 if(fontwidth==0) return; //Kein Font ausgewhlt

 xp=xpos; yp=ypos;
 
 while((__ps = *__putstr))
  {
   __putstr++;
   if (__ps== 0) break;
   LCDSoftChar(__ps,xp,yp);
   xp+=fontwidth; //Nchstes Zeichen
   if(xp>=LCD_WIDTH) { xp=0; yp+=fontheight; } //Nchste Zeile
  }
}
